<template>
  <section class="trackRow" @click="playTrack()" v-bind:class="{ active: isActive, error: track.hasError }">
    <section class="trackRow__imageWrapper">
      <section class="trackRow__image" v-bind:style="{ backgroundImage: 'url(' + (track.artist.picture_medium || track.album.cover_medium) + ')' }"></section>
    </section>
    <section class="playIcon">
      <md-icon v-if="!isPlaying || !isActive">play_arrow</md-icon>
      <md-icon v-if="isPlaying && isActive">pause</md-icon>
    </section>
    <section class="trackRow__meta">
      <section class="trackRow__title">{{track.title}}</section>
      <section class="trackRow__artist">{{track.artist.name}}</section>
    </section>
    <section class="trackRow__info">
      <section class="trackRow__ablumTitle" v-if="track.album">{{track.album.title}}</section>
      <section class="trackRow__duration">{{track.duration | trackTime}}</section>
    </section>
  </section>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';

@Component({
  props: {
    track: Object,
    isPlaying: Boolean,
    isActive: Boolean,
  },
})
export default class TrackRow extends Vue {
  playTrack() {
    if (this.isPlaying && this.isActive) {
      this.$store.dispatch('pause');
    } else {
      this.$store.dispatch('play', this.track);
    }
  }
}
</script>

<style lang="stylus" scoped>
.trackRow
  position relative
  width 100%
  height 64px
  padding 6px 10px
  display flex
  align-items center
  border-left 1px solid transparent
  border-bottom 1px solid rgba(255,255,255,.01)
  cursor pointer
  &:hover
    background-color rgba(255,255,255,.009)
    .playIcon
      display block
    .trackRow__image
      opacity .3

  &.active
    border-left 1px solid yellow
    background-color rgba(255,255,255,.02)
    .playIcon
      display block
    .trackRow__image
      opacity .3

  &.error
    background-color rgba(90,0,0,.2)

  .playIcon
    position absolute
    top 20px
    left 18px
    display none

  &__imageWrapper
    position relative
    width 40px
    min-width 40px
    height 40px
    border-radius 50%
    overflow hidden

  &__image
    width 40px
    height 40px
    background-size cover
  
  &__meta
    padding-left 12px
    display flex
    flex-direction column
    align-items flex-start
    justify-content center

  &__title
    width 230px
    max-width 100%
    font-size 14px
    font-weight 500
    word-wrap break-word
    white-space nowrap
    overflow hidden
    text-overflow ellipsis

  &__artist
    color rgb(86,92,105)
    font-size 12px
    font-weight bold

  &__info
    min-width 130px
    margin-left auto
    display flex
    justify-content flex-end
    align-items center

  &__duration
    margin-left 10px
    display flex
    align-items center
    font-size 12px
    font-weight bold

  &__ablumTitle
    width 200px
    max-width 200px
    margin-left auto
    padding-right 10px
    display block
    text-align right
    color rgb(86,92,105)
    overflow hidden
    white-space nowrap
    text-overflow ellipsis
    font-size 12px
    font-weight bold

</style>

